<script setup lang="ts">
import { watch } from "vue";
import { useImageVerify } from "./hooks";

defineOptions({
  name: "ReImageVerify"
});

interface Props {
  code?: string;
  password?: string;
}

interface Emits {
  (e: "update:code", code: string): void;
  (e: "update:password", password: string): void;
}

const props = withDefaults(defineProps<Props>(), {
  code: "",
  password: ""
});

const emit = defineEmits<Emits>();

const { domRef, imgCode, password, setImgCode, getImgCode } = useImageVerify();

watch(
  () => props.code,
  newValue => {
    setImgCode(newValue);
  }
);
watch(imgCode, newValue => {
  emit("update:code", newValue);
});

watch(password, newValue => {
  emit("update:password", newValue);
});

defineExpose({ getImgCode });
</script>

<template>
  <canvas
    ref="domRef"
    width="120"
    height="40"
    class="cursor-pointer"
    @click="getImgCode"
  />
</template>
